%global ovirt_user_description oVirt Manager
%global engine_name ovirt-engine
%global engine_state %{_localstatedir}/lib/%{engine_name}
%global engine_gid 108
%global engine_group ovirt
%global engine_uid 108
%global engine_user ovirt

# Macro to create an user:
# %1 user name
# %2 user id
# %3 primary group name
# %4 primary group id
# %5 description
# %6 home directory

%global _ovirt_create_user() \
getent group %3 >/dev/null || groupadd -r -g %4 %3; \
getent passwd %1 >/dev/null || useradd -r -u %2 -g %3 -c %5 -s /sbin/nologin -d %6 %1

%global ovirt_create_user_engine \
%_ovirt_create_user %{engine_user} %{engine_uid} %{engine_group} %{engine_gid} "%{ovirt_user_description}" %{engine_state}

Name:			redhat-access-plugin-rhsc
Version:		2.1.2
Release:		3%{?release_suffix}%{?dist}
Summary:		Plugin for Red Hat Enterprise Virtualization

Group:			Development/Libraries
License:		ASL 2.0
URL:			http://www.ovirt.org
BuildArch:		noarch
Source0: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-2.1.2-scm-sources.zip
Source1: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-ear-2.1.2.ear
Source2: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-ear-2.1.2.pom
Source3: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-war-2.1.2.war
Source4: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-war-2.1.2.pom
Source5: http://people.redhat.com/sshumake/projects/redhat-access-plugin-rhsc/redhat-access-plugin-rhsc-2.1.2.pom

Obsoletes: redhat-access-plugin-storage
Requires: rhsc >= 2.1.2
Requires: usermode

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
The Red Hat Access Plugin is a support 
plugin for RHSC

%prep
# We build RHSC in the MEAD environment, and that means that the
# sources are archived with root based on repository name

%setup -q -T -b 0 -n redhat-access-plugin-storage

%build

%install
rm -rf %{buildroot}

# ovirt-engine owns the following folders, but we need them for later steps
install -d %{buildroot}/usr/share/ovirt-engine/
install -d %{buildroot}/etc/ovirt-engine/

# We need the following directory to deploy the ear file
install -d %{buildroot}/etc/ovirt-engine/engine.conf.d/

# We need the following directories for the ovirt-sosreport wrapper
install -d %{buildroot}/etc/security/console.apps
install -d %{buildroot}/etc/pam.d
install -d %{buildroot}/usr/bin
install -d %{buildroot}/usr/sbin

# We need the following directories for httpd config
install -d %{buildroot}/etc/httpd/conf.d

# We need the following directories for ovirt-engine-setup
install -d %{buildroot}/usr/share/ovirt-engine/setup/plugins/ovirt-engine-setup/
install -d %{buildroot}/usr/share/ovirt-engine/setup/ovirt_engine_setup/

# We need the following directory for GSS DB wrapper script
install -d %{buildroot}/var/lib/ovirt-engine/db-manual

echo "Skipping artifact"
mkdir %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear
unzip -d %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear %{SOURCE1}
find %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear -type d -exec chmod 755 {} +
#install -D %{SOURCE1} %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear 
echo "Skipping artifact"
echo "Skipping artifact"
echo "Skipping artifact"
echo "Skipping artifact"

pushd %{buildroot}/usr/share/ovirt-engine
ln -s redhat-access-plugin-rhsc-ear-2.1.2.ear redhat-access-plugin-rhsc.ear
popd

# Copy these two files that are required for the plugin
cp -r ui-plugins %{buildroot}/usr/share/ovirt-engine/ui-plugins
install -m 644 redhataccessplugin.conf %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear/

#Add version to config file 
printf "\nversion=com.redhat.gss-redhat-access-plugin-rhsc-2.1.2-3" >> %{buildroot}/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear/redhataccessplugin.conf

# Copy file to deploy ear file
install -m 644 deploy/50-redhat-access-plugin.conf %{buildroot}/etc/ovirt-engine/engine.conf.d/

# Install ovirt-sosreport wrapper.
install -m 755 utils/ovirt-sosreport-wrapper %{buildroot}/usr/sbin/ovirt-sosreport-wrapper
install -m 644 utils/ovirt-sosreport.pam %{buildroot}/etc/pam.d/ovirt-sosreport
install -m 644 utils/ovirt-sosreport.console-apps %{buildroot}/etc/security/console.apps/ovirt-sosreport

#Install proxy setup in ovirt-engine
cp -r utils/ovirt-engine-setup-plugin/redhataccessplugin %{buildroot}/usr/share/ovirt-engine/setup/plugins/ovirt-engine-setup
install -m 644 utils/ovirt-engine-setup-plugin/constants_access_plugin.py %{buildroot}/usr/share/ovirt-engine/setup/ovirt_engine_setup/constants_access_plugin.py

ln -s /usr/bin/consolehelper %{buildroot}/usr/bin/ovirt-sosreport

# Install httpd config
install -m 644 httpd-conf/redhat-access-plugin-rhsc-proxy.conf %{buildroot}/etc/httpd/conf.d

# Install GSS DB wrapper script
install -m 755 packaging/bin/engine-psql.sh %{buildroot}/var/lib/ovirt-engine/db-manual

%pre
%ovirt_create_user_engine


%files
%defattr(-,ovirt,ovirt,-)
/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear
/usr/share/ovirt-engine/redhat-access-plugin-rhsc.ear
%config(noreplace)  /etc/ovirt-engine/engine.conf.d/50-redhat-access-plugin.conf
%dir /usr/share/ovirt-engine/ui-plugins/redhat-access-plugin-rhsc
/usr/share/ovirt-engine/ui-plugins/*
/usr/share/ovirt-engine/redhat-access-plugin-rhsc-ear-2.1.2.ear/redhataccessplugin.conf
%defattr(-,root,root,-)
%config(noreplace) /etc/pam.d/ovirt-sosreport
%config(noreplace) /etc/security/console.apps/ovirt-sosreport
/usr/bin/ovirt-sosreport
/usr/sbin/ovirt-sosreport-wrapper
%config(noreplace) /etc/httpd/conf.d/redhat-access-plugin-rhsc-proxy.conf
/usr/share/ovirt-engine/setup/plugins/ovirt-engine-setup/*
/usr/share/ovirt-engine/setup/ovirt_engine_setup/*
/var/lib/ovirt-engine/db-manual/engine-psql.sh
%doc LICENSE

%posttrans
# If this is an upgrade, make sure application.xml modifications are removed.
if [ -f /usr/share/ovirt-engine/engine.ear/META-INF/application.xml ]; then
    if grep -q 'START Red Hat Support Plug-in DO NOT REMOVE THIS COMMENT' /usr/share/ovirt-engine/engine.ear/META-INF/application.xml; then
    	sed  -i '/<!-- START Red Hat Support Plug-in DO NOT REMOVE THIS COMMENT -->/,/<!-- END Red Hat Support Plug-in DO NOT REMOVE THIS COMMENT -->/d' /usr/share/ovirt-engine/engine.ear/META-INF/application.xml
	fi
fi


# RHSC Support Plugin installed - tell JBoss that we want engine.ear redeployed to action it.
if [ -d /var/lib/ovirt-engine/deployments ] ; then
	touch /var/lib/ovirt-engine/deployments/engine.ear.dodeploy
fi

chown ovirt /usr/share/ovirt-engine/ui-plugins
chgrp ovirt /usr/share/ovirt-engine/ui-plugins

%changelog
* Wed Jan 8 2014 Spenser Shumaker <sshumake@redhat.com> - 2.1.2-3
- Resolves: rhbz1048247

* Mon Nov 25 2013 Spenser Shumaker <sshumake@redhat.com> - 2.1.2-2
- Resolves: rhbz1007751
- Resolves: rhbz1030784
- Resolves: rhbz1030248
- Resolves: rhbz1030232

* Wed Nov 6 2013 Spenser Shumaker <sshumake@redhat.com> - 2.1.2-1
- Resolves: rhbz1012144
- Resolves: rhbz1022338

* Thu Aug 29 2013 Spenser Shumaker <sshumake@redhat.com> - 2.1.0-0
- Review Request: redhat-access-plugin-storage - RHS Plug-in for interacting with subscriber services
- Resolves: rhbz999245

* Wed Apr 10 2013 Spenser Shumaker <sshumake@redhat.com> - 1.0.0-0
- Initial build
